package com.example.musicbynumbers;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.widget.EditText;
import android.widget.TextView;

public class DatabaseHelper extends SQLiteOpenHelper {
    public static final String DATABASE_NAME = "mediaPlayer.db";
    public static final String TABLE_NAME = "playList";
    public static final String COL1 = "ID";
    public static final String COL2 = "SONG_NAME";
    EditText etSongName;



    public DatabaseHelper(Context context) {
        super(context, DATABASE_NAME, null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL("create table " + TABLE_NAME + "(ID INTEGER PRIMARY KEY AUTOINCREMENT, SONG_NAME TEXT UNIQUE, GENRE TEXT, DURATION INTEGER)");
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE IF EXISTS " + TABLE_NAME);
        onCreate(db);
    }

    public boolean insertData(String SONG_NAME, String GENRE, String DURATION){
        SQLiteDatabase db = this.getWritableDatabase();
        ContentValues contentValues = new ContentValues();
        contentValues.put(COL2, SONG_NAME);
        long result = db.insert(TABLE_NAME, null, contentValues);
        if (result == -1){
            return false;
        }
        else
        {
            return true;
        }
    }

    public void deleteSong(String txtSongName){
        this.getWritableDatabase().delete("playList", "SONG_NAME='"+ txtSongName +"'", null);
    }

    public void updateSong(String oldSong, String newSong){
        this.getWritableDatabase().execSQL("UPDATE playList SET SONG_NAME='" + newSong + "' WHERE SONG_NAME='" + oldSong+"'");
    }

    public void listPlaylist(TextView textView){
        Cursor cursor = this.getReadableDatabase().rawQuery("SELECT * FROM playList", null);
        textView.setText("");
        while(cursor.moveToNext()){
            textView.append(cursor.getString(1)+ "\n");
        }

    }
}
