package com.example.musicbynumbers;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.graphics.PorterDuff;
import android.media.MediaPlayer;
import android.net.Uri;
import android.provider.MediaStore;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;

import java.io.File;
import java.util.ArrayList;

public class PlayerActivity extends AppCompatActivity {

    DatabaseHelper myDB;
    Button btn_next, btn_prev, btn_pause;
    TextView songTextLabel;
    SeekBar songSeekBar;
    String sname;
    static MediaPlayer myMediaPlayer;
    int position;
    int count = 1;

    ArrayList<File> mySongs;
    Thread updateseekBar;


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if(item.getItemId() == android.R.id.home){
            onBackPressed();
            myMediaPlayer.stop();
        }
        return super.onOptionsItemSelected(item);
    }

    @SuppressLint("NewApi")
    @Override
    protected void onCreate(final Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_player);

        btn_next = (Button)findViewById(R.id.next);
        btn_prev = (Button)findViewById(R.id.prev);
        btn_pause = (Button)findViewById(R.id.pause);
        songTextLabel = (TextView)findViewById(R.id.songViewLabel);
        songSeekBar = (SeekBar)findViewById(R.id.seekBar);
        Bundle extras = getIntent().getExtras();

        getSupportActionBar().setTitle("Now Playing");
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);

        updateseekBar = new Thread(){
            @Override
            public void run() {
                int totalDuration = myMediaPlayer.getDuration();
                final int[] currentPosition = {0};


                while(position != mySongs.size()) {

                        if (myMediaPlayer.isPlaying()) {
                            try {
                                sleep(500);
                                currentPosition[0] = myMediaPlayer.getCurrentPosition();
                                songSeekBar.setProgress(currentPosition[0]);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                        }

                        myMediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                            @Override
                            public void onCompletion(MediaPlayer mp) {

                                    myMediaPlayer.release();

                                    position = ((position + 1) % mySongs.size());

                                    Uri u = Uri.parse(mySongs.get(position).toString());
                                    myMediaPlayer = MediaPlayer.create(getApplicationContext(), u);

                                    songSeekBar.setProgress(0);
                                    songSeekBar.setMax(myMediaPlayer.getDuration());

                                    sname = mySongs.get(position).getName().toString();
                                    songTextLabel.setText(sname);
                                    myMediaPlayer.start();
                                    count += 1;
                                }


                        });

                        /*if (globalNumOfSongs == count) {
                            myMediaPlayer.release();
                            startActivity(new Intent(PlayerActivity.this, HomeActivity.class));
                        }*/

                    }
                }

        };

        //if(myMediaPlayer != null){
         //   myMediaPlayer.stop();
        //    myMediaPlayer.release();
        //}
        Intent i = getIntent();
        Bundle bundle = i.getExtras();

        mySongs=(ArrayList) bundle.getParcelableArrayList("songs");

        sname = mySongs.get(position).getName().toString();

        String songName = i.getStringExtra("songname");

        songTextLabel.setText(songName);
        songTextLabel.setSelected(true);

        position = bundle.getInt("pos", 0);

        Uri u = Uri.parse(mySongs.get(position).toString());

        myMediaPlayer = MediaPlayer.create(this, u);

        myMediaPlayer.start();
        songSeekBar.setMax(myMediaPlayer.getDuration());

        updateseekBar.start();

        songSeekBar.getProgressDrawable().setColorFilter(getResources().getColor(R.color.colorPrimary), PorterDuff.Mode.MULTIPLY);
        songSeekBar.getThumb().setColorFilter(getResources().getColor(R.color.colorPrimary), PorterDuff.Mode.SRC_IN);

        songSeekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {

            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                myMediaPlayer.seekTo(seekBar.getProgress());
            }
        });


        btn_pause.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view){

                if(myMediaPlayer.isPlaying()){
                    btn_pause.setBackgroundResource(R.drawable.icon_play);
                    myMediaPlayer.pause();
                }
                else{
                    btn_pause.setBackgroundResource(R.drawable.icon_pause);
                    myMediaPlayer.start();
                }
            }
        });
        btn_next.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view){
                myMediaPlayer.release();
                position = ((position+1)%mySongs.size());

                Uri u = Uri.parse(mySongs.get(position).toString());
                myMediaPlayer = MediaPlayer.create(getApplicationContext(), u);

                sname = mySongs.get(position).getName().toString();
                songTextLabel.setText(sname);
                songSeekBar.setProgress(0);
                btn_pause.setBackgroundResource(R.drawable.icon_pause);

                myMediaPlayer.start();
            }
        });
        btn_prev.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view){
                myMediaPlayer.release();
                position = ((position-1) < 0)?(mySongs.size()-1):(position-1);

                Uri u = Uri.parse((mySongs.get(position).toString()));
                myMediaPlayer = MediaPlayer.create(getApplicationContext(), u);

                sname = mySongs.get(position).getName().toString();
                songTextLabel.setText(sname);
                songSeekBar.setProgress(0);
                btn_pause.setBackgroundResource(R.drawable.icon_pause);

                myMediaPlayer.start();
            }
        });



    }

}
